import React, { Dispatch, SetStateAction } from 'react';
import { OperationResult } from './DependentTabs';
import { DFData, DFViewerConfig } from './DFViewerParts/DFWhole';
import { BuckarooState } from './WidgetTypes';
import { BuckarooOptions } from './WidgetTypes';
import { DFMeta } from './WidgetTypes';
import { CommandConfigT } from './CommandUtils';
import { Operation } from './OperationUtils';
export type CommandConfigSetterT = (setter: Dispatch<SetStateAction<CommandConfigT>>) => void;
export interface IDisplayArgs {
    data_key: string;
    df_viewer_config: DFViewerConfig;
    summary_stats_key: string;
}
export declare function WidgetDCFCell({ df_data_dict, df_display_args, df_meta, operations, on_operations, operation_results, commandConfig, buckaroo_state, on_buckaroo_state, buckaroo_options, }: {
    df_meta: DFMeta;
    df_data_dict: Record<string, DFData>;
    df_display_args: Record<string, IDisplayArgs>;
    operations: Operation[];
    on_operations: (ops: Operation[]) => void;
    operation_results: OperationResult;
    commandConfig: CommandConfigT;
    buckaroo_state: BuckarooState;
    on_buckaroo_state: React.Dispatch<React.SetStateAction<BuckarooState>>;
    buckaroo_options: BuckarooOptions;
}): React.JSX.Element;
export declare function WidgetDCFCellExample(): React.JSX.Element;
