"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WidgetDCFCellExample = exports.WidgetDCFCell = void 0;
const react_1 = __importStar(require("react"));
const DependentTabs_1 = require("./DependentTabs");
const ColumnsEditor_1 = require("./ColumnsEditor");
const staticData_1 = require("../baked_data/staticData");
const DFViewer_1 = require("./DFViewerParts/DFViewer");
const StatusBar_1 = require("./StatusBar");
const bakedOperationDefaults_1 = require("./bakedOperationDefaults");
const OperationUtils_1 = require("./OperationUtils");
function WidgetDCFCell({ df_data_dict, df_display_args, df_meta, operations, on_operations, operation_results, commandConfig, buckaroo_state, on_buckaroo_state, buckaroo_options, }) {
    const [activeCol, setActiveCol] = (0, react_1.useState)('stoptime');
    const cDisp = df_display_args[buckaroo_state.df_display];
    if (cDisp === undefined) {
        console.log('cDisp undefined', buckaroo_state.df_display, buckaroo_options.df_display);
    }
    else {
        //  console.log("cDisp", cDisp);
    }
    const dfData = df_data_dict[cDisp.data_key];
    //console.log("dfData", dfData);
    const summaryStatsData = df_data_dict[cDisp.summary_stats_key];
    return (react_1.default.createElement("div", { className: "dcf-root flex flex-col", style: { width: '100%', height: '100%' } },
        react_1.default.createElement("div", { className: "orig-df flex flex-row", style: {
                // height: '450px',
                overflow: 'hidden',
            } },
            react_1.default.createElement(StatusBar_1.StatusBar, { dfMeta: df_meta, buckarooState: buckaroo_state, setBuckarooState: on_buckaroo_state, buckarooOptions: buckaroo_options }),
            react_1.default.createElement(DFViewer_1.DFViewer, { df_data: dfData, df_viewer_config: cDisp.df_viewer_config, summary_stats_data: summaryStatsData, activeCol: activeCol, setActiveCol: setActiveCol })),
        buckaroo_state.show_commands ? (react_1.default.createElement(ColumnsEditor_1.ColumnsEditor, { df_viewer_config: cDisp.df_viewer_config, activeColumn: activeCol, operations: operations, setOperations: on_operations, operationResult: operation_results, commandConfig: commandConfig })) : (react_1.default.createElement("span", null))));
}
exports.WidgetDCFCell = WidgetDCFCell;
function WidgetDCFCellExample() {
    const dfm = {
        columns: 5,
        rows_shown: 20,
        filtered_rows: 89,
        total_rows: 877,
    };
    const [bState, setBState] = (0, react_1.useState)({
        auto_clean: '',
        sampled: false,
        show_commands: false,
        df_display: 'main',
        post_processing: '',
        search_string: '',
    });
    const bOptions = {
        auto_clean: ['', 'aggressive', 'conservative'],
        df_display: ['main', 'realSummary', 'no_pinned'],
        sampled: ['random'],
        post_processing: ['', 'foo', 'bar'],
        show_commands: ['on'],
        //    'summary_stats' : ['full', 'all', 'typing_stats']
    };
    const [operations, setOperations] = (0, react_1.useState)(OperationUtils_1.bakedOperations);
    const bakedDfDisplay = {
        main: {
            data_key: 'main',
            df_viewer_config: staticData_1.tableDf.dfviewer_config,
            summary_stats_key: 'all',
        },
        realSummary: {
            data_key: 'empty',
            df_viewer_config: staticData_1.realSummaryConfig,
            summary_stats_key: 'real_summary',
        },
        no_pinned: {
            data_key: 'main',
            df_viewer_config: staticData_1.dfviewer_config_no_pinned,
            summary_stats_key: 'all',
        },
    };
    const df_data_dict = {
        main: staticData_1.tableDf.data,
        all: staticData_1.summaryDfForTableDf,
        real_summary: staticData_1.realSummaryTableData,
        empty: [{ index: 'distinct_count' }],
    };
    return (react_1.default.createElement(WidgetDCFCell, { df_meta: dfm, df_display_args: bakedDfDisplay, df_data_dict: df_data_dict, buckaroo_options: bOptions, buckaroo_state: bState, on_buckaroo_state: setBState, commandConfig: bakedOperationDefaults_1.bakedCommandConfig, operations: operations, on_operations: setOperations, operation_results: DependentTabs_1.baseOperationResults }));
}
exports.WidgetDCFCellExample = WidgetDCFCellExample;
//# sourceMappingURL=DCFCell.js.map