import { ValueFormatterFunc, ValueFormatterParams } from 'ag-grid-community';
import { DisplayerArgs, FloatDisplayerA, DatetimeLocaleDisplayerA, StringDisplayerA, ObjDisplayerA } from './DFWhole';
import { CellRendererArgs, FormatterArgs } from './DFWhole';
export declare const basicIntFormatter: Intl.NumberFormat;
export declare const getStringFormatter: (args: StringDisplayerA) => (params: ValueFormatterParams) => string;
export declare const isValidDate: (possibleDate: any) => boolean;
export declare const dateDisplayerDefault: (d: Date) => string;
export declare const getObjectFormatter: (fArgs: ObjDisplayerA) => (params: ValueFormatterParams) => string;
export declare const objFormatter: (params: ValueFormatterParams) => string;
export declare const boolDisplayer: (val: boolean) => "" | "False" | "True";
export declare const booleanFormatter: (params: ValueFormatterParams) => string;
export declare const getFloatFormatter: (hint: FloatDisplayerA) => (params: ValueFormatterParams) => string;
export declare const getDatetimeFormatter: (colHint: DatetimeLocaleDisplayerA) => (params: ValueFormatterParams) => string;
export declare const defaultDatetimeFormatter: (params: ValueFormatterParams) => string;
export declare function getFormatter(fArgs: FormatterArgs): ValueFormatterFunc<unknown>;
export declare function getCellRenderer(crArgs: CellRendererArgs): ((props: any) => import("react").JSX.Element) | "agCheckboxCellRenderer";
export declare function getFormatterFromArgs(dispArgs: DisplayerArgs): ValueFormatterFunc<unknown, any> | undefined;
