import { CellClassParams, CellRendererSelectorResult, ColDef, ICellRendererParams } from 'ag-grid-community';
import { DFWhole, DisplayerArgs, ColorMappingConfig, ColorMapRules, TooltipConfig, ColorWhenNotNullRules, DFViewerConfig } from './DFWhole';
import { DFData, SDFMeasure, SDFT } from './DFWhole';
import { PinnedRowConfig } from './DFWhole';
export declare function addToColDef(dispArgs: DisplayerArgs, summary_stats_column: SDFMeasure): ColDef<any, any> | undefined;
export declare function getHistoIndex(val: number, histogram_edges: number[]): number;
export declare function colorMap(cmr: ColorMapRules, histogram_edges: number[]): {
    cellStyle: (params: CellClassParams) => {
        backgroundColor: string;
    };
};
export declare function colorNotNull(cmr: ColorWhenNotNullRules): {
    cellStyle: (params: CellClassParams) => {
        backgroundColor: string;
    };
};
export declare function getStyler(cmr: ColorMappingConfig, col_name: string, histogram_stats: SDFT): {} | undefined;
export declare function extractPinnedRows(sdf: DFData, prc: PinnedRowConfig[]): (import("./DFWhole").DFDataRow | undefined)[];
export declare function getTooltip(ttc: TooltipConfig, single_series_summary_df: DFWhole): Partial<ColDef>;
export declare function extractSingleSeriesSummary(full_summary_stats_df: DFData, col_name: string): DFWhole;
export declare function dfToAgrid(tdf: DFData, dfviewer_config: DFViewerConfig, full_summary_stats_df: DFData): [ColDef[], unknown[]];
export declare function getCellRendererSelector(pinned_rows: PinnedRowConfig[]): (params: ICellRendererParams<any, any, any>) => CellRendererSelectorResult | undefined;
export declare function extractSDFT(summaryStatsDf: DFData): SDFT;
