import React, { CSSProperties, Dispatch, SetStateAction } from 'react';
import { DFWhole } from './DFViewerParts/DFWhole';
import { Operation } from './OperationUtils';
export declare function OperationDisplayer({ filledOperations, style, }: {
    filledOperations: Operation[];
    style: CSSProperties;
}): React.JSX.Element;
export declare function PythonDisplayer({ style, generatedPyCode, }: {
    style: CSSProperties;
    generatedPyCode: string;
}): React.JSX.Element;
export declare function TransformViewer({ style, transformedDf, }: {
    style: CSSProperties;
    transformedDf: DFWhole;
}): React.JSX.Element;
export type OperationResult = {
    transformed_df: DFWhole;
    generated_py_code: string;
    transform_error?: string;
};
export type OrRequesterT = (ops: Operation[]) => void;
export type getOperationResultSetterT = (setter: Dispatch<SetStateAction<OperationResult>>) => OrRequesterT;
export declare const baseOperationResults: OperationResult;
export declare function TabComponent({ currentTab, _setTab, tabName, }: {
    currentTab: any;
    _setTab: any;
    tabName: any;
}): JSX.Element;
export declare function DependentTabs({ filledOperations, operationResult, }: {
    filledOperations: Operation[];
    operationResult: OperationResult;
}): React.JSX.Element;
