"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DependentTabs = exports.TabComponent = exports.baseOperationResults = exports.TransformViewer = exports.PythonDisplayer = exports.OperationDisplayer = void 0;
const react_1 = __importStar(require("react"));
const DFWhole_1 = require("./DFViewerParts/DFWhole");
function OperationDisplayer({ filledOperations, style, }) {
    const baseStyle = { margin: '0', textAlign: 'left' };
    const localStyle = Object.assign(Object.assign({}, baseStyle), style);
    return (react_1.default.createElement("div", { className: "command-displayer", style: { width: '100%' } },
        react_1.default.createElement("pre", { style: localStyle }, JSON.stringify(filledOperations))));
}
exports.OperationDisplayer = OperationDisplayer;
function PythonDisplayer({ style, generatedPyCode, }) {
    const baseStyle = { margin: '0', textAlign: 'left' };
    const localStyle = Object.assign(Object.assign({}, baseStyle), style);
    return (react_1.default.createElement("div", { className: "python-displayer", style: { width: '100%' } },
        react_1.default.createElement("pre", { style: localStyle }, generatedPyCode)));
}
exports.PythonDisplayer = PythonDisplayer;
function TransformViewer({ style, transformedDf, }) {
    return react_1.default.createElement("div", { className: "transform-viewer" }, "\"transformed view\"");
}
exports.TransformViewer = TransformViewer;
exports.baseOperationResults = {
    transformed_df: DFWhole_1.EmptyDf,
    generated_py_code: 'default py code',
};
function TabComponent({ currentTab, _setTab, tabName, }) {
    return (react_1.default.createElement("li", { onClick: () => {
            _setTab(tabName);
        }, className: currentTab === tabName ? 'active' : '' }, tabName));
}
exports.TabComponent = TabComponent;
function DependentTabs({ filledOperations, operationResult, }) {
    const [tab, _setTab] = (0, react_1.useState)('DataFrame');
    const style = { height: '45vh' };
    return (react_1.default.createElement("div", { className: "dependent-tabs", style: { width: '100%' } },
        react_1.default.createElement("ul", { className: "tabs" },
            react_1.default.createElement(TabComponent, { currentTab: tab, _setTab: _setTab, tabName: 'DataFrame' }),
            react_1.default.createElement(TabComponent, { currentTab: tab, _setTab: _setTab, tabName: 'Python' }),
            react_1.default.createElement(TabComponent, { currentTab: tab, _setTab: _setTab, tabName: 'Operations' })),
        react_1.default.createElement("div", { className: "output-area" },
            operationResult.transform_error ? (react_1.default.createElement("div", null,
                react_1.default.createElement("h2", null, " error "),
                react_1.default.createElement(PythonDisplayer, { style: style, generatedPyCode: operationResult.transform_error }))) : (react_1.default.createElement("span", null)),
            {
                Operations: (react_1.default.createElement(OperationDisplayer, { style: style, filledOperations: filledOperations })),
                Python: (react_1.default.createElement(PythonDisplayer, { style: style, generatedPyCode: operationResult.generated_py_code })),
                DataFrame: (react_1.default.createElement(TransformViewer, { style: style, transformedDf: operationResult.transformed_df })),
            }[tab])));
}
exports.DependentTabs = DependentTabs;
//# sourceMappingURL=DependentTabs.js.map