"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatusBar = void 0;
// https://plnkr.co/edit/QTNwBb2VEn81lf4t?open=index.tsx
const react_1 = __importStar(require("react"));
const lodash_1 = __importDefault(require("lodash"));
const ag_grid_react_1 = require("ag-grid-react"); // the AG Grid React Component
const Displayer_1 = require("./DFViewerParts/Displayer");
const getSearchForm = (initialVal, setSearchVal) => {
    return function MyForm() {
        function handleSubmit(e) {
            // Prevent the browser from reloading the page
            e.preventDefault();
            // Read the form data
            const form = e.target;
            const formData = new FormData(form);
            const entries = Array.from(formData.entries());
            const formDict = lodash_1.default.fromPairs(entries);
            console.log('formDict', formDict);
            setSearchVal(formDict['search']);
        }
        return (react_1.default.createElement("form", { method: "post", onSubmit: handleSubmit },
            react_1.default.createElement("label", null,
                react_1.default.createElement("input", { name: "search", defaultValue: initialVal }))));
    };
};
const helpCell = function (params) {
    return (react_1.default.createElement("a", { href: "https://buckaroo-data.readthedocs.io/en/latest/feature_reference.html", target: "_blank", rel: "noopener" }, "?"));
};
function StatusBar({ dfMeta, buckarooState, setBuckarooState, buckarooOptions, }) {
    console.log('initial buckarooState', buckarooState);
    //   const optionCycles = _.fromPairs(
    // //    _.map(buckarooOptions, (v: any, k) => [k, ( k==='df_display' ? v :  _.concat([false], v) ) ])
    //     _.map(buckarooOptions, (v: any, k) => [k, ( k==='post_processing' ? v :  _.concat([false], v) ) ])
    //   ) as Record<BKeys, any[]>;
    const optionCycles = buckarooOptions;
    const idxs = lodash_1.default.fromPairs(lodash_1.default.map(lodash_1.default.keys(optionCycles), (k) => [
        k,
        lodash_1.default.indexOf(optionCycles[k], buckarooState[k]),
    ]));
    const nextIndex = (curIdx, arr) => {
        if (curIdx === arr.length - 1) {
            return 0;
        }
        return curIdx + 1;
    };
    const newBuckarooState = (k) => {
        const arr = optionCycles[k];
        const curIdx = idxs[k];
        const nextIdx = nextIndex(curIdx, arr);
        const newVal = arr[nextIdx];
        const newState = lodash_1.default.clone(buckarooState);
        newState[k] = newVal;
        return newState;
    };
    const updateDict = (event) => {
        const colName = event.column.getColId();
        if (colName === 'search') {
            return;
        }
        if (lodash_1.default.includes(lodash_1.default.keys(buckarooState), colName)) {
            const nbstate = newBuckarooState(colName);
            setBuckarooState(nbstate);
        }
    };
    const showSearch = false;
    const localSetSearchString = (search_query) => {
        setBuckarooState(Object.assign(Object.assign({}, buckarooState), { search_string: search_query }));
    };
    const columnDefs = [
        {
            field: 'search',
            width: 200,
            cellRenderer: getSearchForm(buckarooState.search_string, localSetSearchString),
            hide: !showSearch,
        },
        {
            field: 'df_display',
            headerName: 'Σ',
            headerTooltip: 'Summary Stats',
            width: 120,
        },
        /*
        {
          field: 'auto_clean',
          //headerName: 'Σ', //note the greek symbols instead of icons which require buildchain work
          headerName: 'auto cleaning',
          headerTooltip: 'Auto Cleaning config',
          width: 120,
        },
        */
        {
            field: 'post_processing',
            //      headerName: "Θ",
            headerName: 'post processing',
            headerTooltip: 'post process method',
            width: 100,
        },
        {
            field: 'show_commands',
            headerName: 'λ',
            headerTooltip: 'Show Commands',
            width: 30,
        },
        { field: 'sampled', headerName: 'Ξ', headerTooltip: 'Sampled', width: 30 },
        {
            field: 'help',
            headerName: '?',
            headerTooltip: 'Help',
            width: 30,
            cellRenderer: helpCell,
        },
        { field: 'total_rows', width: 100 },
        { field: 'filtered_rows', headerName: 'filtered', width: 85 },
        { field: 'rows_shown', headerName: 'displayed', width: 85 },
        { field: 'columns', width: 75 },
    ];
    const rowData = [
        {
            total_rows: Displayer_1.basicIntFormatter.format(dfMeta.total_rows),
            columns: dfMeta.columns,
            rows_shown: Displayer_1.basicIntFormatter.format(dfMeta.rows_shown),
            sampled: buckarooState.sampled || '0',
            auto_clean: buckarooState.auto_clean || '0',
            df_display: buckarooState.df_display,
            filtered_rows: Displayer_1.basicIntFormatter.format(dfMeta.filtered_rows),
            post_processing: buckarooState.post_processing,
            show_commands: buckarooState.show_commands || '0',
        },
    ];
    const gridOptions = {
        suppressRowClickSelection: true,
    };
    const gridRef = (0, react_1.useRef)(null);
    const defaultColDef = {
        cellStyle: { textAlign: 'left' },
    };
    return (react_1.default.createElement("div", { className: "statusBar" },
        react_1.default.createElement("div", { style: { height: 50 }, className: "theme-hanger ag-theme-alpine-dark" },
            react_1.default.createElement(ag_grid_react_1.AgGridReact, { ref: gridRef, onCellClicked: updateDict, gridOptions: gridOptions, defaultColDef: defaultColDef, rowData: rowData, columnDefs: columnDefs }))));
}
exports.StatusBar = StatusBar;
//# sourceMappingURL=StatusBar.js.map