import _ from 'lodash';
import { DFWhole } from './DFViewerParts/DFWhole';
import { ColDef } from 'ag-grid-community';
export type setDFFunc = (newDf: DFWhole) => void;
export declare const requestDf: (url: string, setCallBack: setDFFunc) => Promise<void>;
export declare const sym: (symbolName: string) => {
    symbol: string;
};
export declare function replaceInArr<T>(arr: T[], old: T, subst: T): T[];
export declare function replaceAtIdx<T>(arr: T[], idx: number, subst: T): T[];
export declare function replaceAtKey<T>(obj: Record<string, T>, key: string, subst: T): Record<string, T>;
export declare const objWithoutNull: (obj: Record<string, string>, extraStrips?: string[]) => _.Dictionary<string>;
export declare const updateAtMatch: (cols: ColDef[], key: string, subst: Partial<ColDef>, negative: Partial<ColDef>) => {
    colId?: string | undefined;
    field?: string | undefined;
    type?: string | string[] | undefined;
    cellDataType?: string | boolean | undefined;
    valueGetter?: string | import("ag-grid-community").ValueGetterFunc<any, any> | undefined;
    valueFormatter?: string | import("ag-grid-community").ValueFormatterFunc<any, any> | undefined;
    refData?: {
        [key: string]: string;
    } | undefined;
    keyCreator?: ((params: import("ag-grid-community").KeyCreatorParams<any, any>) => string) | undefined;
    equals?: ((valueA: any, valueB: any) => boolean) | undefined;
    tooltipField?: string | undefined;
    tooltipValueGetter?: ((params: import("ag-grid-community").ITooltipParams<any, any, any>) => any) | undefined;
    checkboxSelection?: boolean | import("ag-grid-community").CheckboxSelectionCallback<any, any> | undefined;
    showDisabledCheckboxes?: boolean | undefined;
    icons?: {
        [key: string]: string | Function;
    } | undefined;
    suppressNavigable?: boolean | import("ag-grid-community").SuppressNavigableCallback<any, any> | undefined;
    suppressKeyboardEvent?: ((params: import("ag-grid-community").SuppressKeyboardEventParams<any, any>) => boolean) | undefined;
    suppressPaste?: boolean | import("ag-grid-community").SuppressPasteCallback<any, any> | undefined;
    suppressFillHandle?: boolean | undefined;
    hide?: boolean | undefined;
    initialHide?: boolean | undefined;
    lockVisible?: boolean | undefined;
    lockPosition?: boolean | "left" | "right" | undefined;
    suppressMovable?: boolean | undefined;
    useValueFormatterForExport?: boolean | undefined;
    editable?: boolean | import("ag-grid-community").EditableCallback<any, any> | undefined;
    valueSetter?: string | import("ag-grid-community").ValueSetterFunc<any, any> | undefined;
    valueParser?: string | import("ag-grid-community").ValueParserFunc<any, any> | undefined;
    cellEditor?: any;
    cellEditorParams?: any;
    cellEditorSelector?: import("ag-grid-community").CellEditorSelectorFunc<any, any> | undefined;
    singleClickEdit?: boolean | undefined;
    cellEditorPopup?: boolean | undefined;
    cellEditorPopupPosition?: "over" | "under" | undefined;
    useValueParserForImport?: boolean | undefined;
    onCellValueChanged?: ((event: import("ag-grid-community").NewValueParams<any, any>) => void) | undefined;
    onCellClicked?: ((event: import("ag-grid-community").CellClickedEvent<any, any>) => void) | undefined;
    onCellDoubleClicked?: ((event: import("ag-grid-community").CellDoubleClickedEvent<any, any>) => void) | undefined;
    onCellContextMenu?: ((event: import("ag-grid-community").CellContextMenuEvent<any, any>) => void) | undefined;
    getQuickFilterText?: ((params: import("ag-grid-community").GetQuickFilterTextParams<any, any>) => string) | undefined;
    filterValueGetter?: string | import("ag-grid-community").ValueGetterFunc<any, any> | undefined;
    floatingFilter?: boolean | undefined;
    suppressFloatingFilterButton?: boolean | undefined;
    wrapHeaderText?: boolean | undefined;
    autoHeaderHeight?: boolean | undefined;
    headerComponent?: any;
    headerComponentParams?: any;
    menuTabs?: import("ag-grid-community").ColumnMenuTab[] | undefined;
    columnChooserParams?: import("ag-grid-community").ColumnChooserParams | undefined;
    columnsMenuParams?: import("ag-grid-community").ColumnsMenuParams | undefined;
    suppressMenu?: boolean | undefined;
    suppressHeaderMenuButton?: boolean | undefined;
    suppressHeaderFilterButton?: boolean | undefined;
    suppressHeaderContextMenu?: boolean | undefined;
    mainMenuItems?: (string | import("ag-grid-community").MenuItemDef<any, any>)[] | import("ag-grid-community").GetMainMenuItems<any, any> | undefined;
    contextMenuItems?: (string | import("ag-grid-community").MenuItemDef<any, any>)[] | import("ag-grid-community").GetContextMenuItems<any, any> | undefined;
    headerCheckboxSelection?: boolean | import("ag-grid-community").HeaderCheckboxSelectionCallback<any, any> | undefined;
    headerCheckboxSelectionFilteredOnly?: boolean | undefined;
    headerCheckboxSelectionCurrentPageOnly?: boolean | undefined;
    chartDataType?: "time" | "category" | "series" | "excluded" | undefined;
    pinned?: boolean | "left" | "right" | null | undefined;
    initialPinned?: boolean | "left" | "right" | undefined;
    lockPinned?: boolean | undefined;
    pivot?: boolean | undefined;
    initialPivot?: boolean | undefined;
    pivotIndex?: number | null | undefined;
    initialPivotIndex?: number | undefined;
    pivotComparator?: ((valueA: string, valueB: string) => number) | undefined;
    enablePivot?: boolean | undefined;
    cellStyle?: import("ag-grid-community").CellStyle | import("ag-grid-community").CellStyleFunc<any, any> | undefined;
    cellClass?: string | string[] | import("ag-grid-community").CellClassFunc<any, any> | undefined;
    cellClassRules?: import("ag-grid-community").CellClassRules<any, any> | undefined;
    cellRenderer?: any;
    cellRendererParams?: any;
    cellRendererSelector?: import("ag-grid-community").CellRendererSelectorFunc<any, any> | undefined;
    autoHeight?: boolean | undefined;
    wrapText?: boolean | undefined;
    enableCellChangeFlash?: boolean | undefined;
    suppressCellFlash?: boolean | undefined;
    rowDrag?: boolean | import("ag-grid-community").RowDragCallback<any, any> | undefined;
    rowDragText?: ((params: import("ag-grid-community").IRowDragItem, dragItemCount: number) => string) | undefined;
    dndSource?: boolean | import("ag-grid-community").DndSourceCallback<any, any> | undefined;
    dndSourceOnRowDrag?: ((params: import("ag-grid-community").DndSourceOnRowDragParams<any>) => void) | undefined;
    rowGroup?: boolean | undefined;
    initialRowGroup?: boolean | undefined;
    rowGroupIndex?: number | null | undefined;
    initialRowGroupIndex?: number | undefined;
    enableRowGroup?: boolean | undefined;
    enableValue?: boolean | undefined;
    aggFunc?: string | import("ag-grid-community").IAggFunc<any, any> | null | undefined;
    initialAggFunc?: string | import("ag-grid-community").IAggFunc<any, any> | undefined;
    defaultAggFunc?: string | undefined;
    allowedAggFuncs?: string[] | undefined;
    showRowGroup?: string | boolean | undefined;
    sortable?: boolean | undefined;
    sort?: import("ag-grid-community").SortDirection | undefined;
    initialSort?: import("ag-grid-community").SortDirection | undefined;
    sortIndex?: number | null | undefined;
    initialSortIndex?: number | undefined;
    sortingOrder?: import("ag-grid-community").SortDirection[] | undefined;
    comparator?: ((valueA: any, valueB: any, nodeA: import("ag-grid-community").IRowNode<any>, nodeB: import("ag-grid-community").IRowNode<any>, isDescending: boolean) => number) | undefined;
    unSortIcon?: boolean | undefined;
    colSpan?: ((params: import("ag-grid-community").ColSpanParams<any, any>) => number) | undefined;
    rowSpan?: ((params: import("ag-grid-community").RowSpanParams<any, any>) => number) | undefined;
    width?: number | undefined;
    initialWidth?: number | undefined;
    minWidth?: number | undefined;
    maxWidth?: number | undefined;
    flex?: number | undefined;
    initialFlex?: number | undefined;
    resizable?: boolean | undefined;
    suppressSizeToFit?: boolean | undefined;
    suppressAutoSize?: boolean | undefined;
    pivotValueColumn?: import("ag-grid-community").Column<any> | null | undefined;
    pivotTotalColumnIds?: string[] | undefined;
    suppressSpanHeaderHeight?: boolean | undefined;
    headerName?: string | undefined;
    headerValueGetter?: string | import("ag-grid-community").HeaderValueGetterFunc<any, any> | undefined;
    headerTooltip?: string | undefined;
    headerClass?: import("ag-grid-community").HeaderClass<any, any> | undefined;
    suppressHeaderKeyboardEvent?: ((params: import("ag-grid-community").SuppressHeaderKeyboardEventParams<any, any>) => boolean) | undefined;
    columnGroupShow?: import("ag-grid-community").ColumnGroupShowType | undefined;
    toolPanelClass?: import("ag-grid-community").ToolPanelClass<any, any> | undefined;
    suppressColumnsToolPanel?: boolean | undefined;
    suppressFiltersToolPanel?: boolean | undefined;
    tooltipComponent?: any;
    tooltipComponentParams?: any;
    pivotKeys?: string[] | undefined;
    cellAriaRole?: string | undefined;
    filter?: any;
    filterParams?: any;
    floatingFilterComponent?: any;
    floatingFilterComponentParams?: any;
}[];
export declare const replaceAtMatch: (cols: ColDef[], key: string, subst: Partial<ColDef>) => {
    colId?: string | undefined;
    field?: string | undefined;
    type?: string | string[] | undefined;
    cellDataType?: string | boolean | undefined;
    valueGetter?: string | import("ag-grid-community").ValueGetterFunc<any, any> | undefined;
    valueFormatter?: string | import("ag-grid-community").ValueFormatterFunc<any, any> | undefined;
    refData?: {
        [key: string]: string;
    } | undefined;
    keyCreator?: ((params: import("ag-grid-community").KeyCreatorParams<any, any>) => string) | undefined;
    equals?: ((valueA: any, valueB: any) => boolean) | undefined;
    tooltipField?: string | undefined;
    tooltipValueGetter?: ((params: import("ag-grid-community").ITooltipParams<any, any, any>) => any) | undefined;
    checkboxSelection?: boolean | import("ag-grid-community").CheckboxSelectionCallback<any, any> | undefined;
    showDisabledCheckboxes?: boolean | undefined;
    icons?: {
        [key: string]: string | Function;
    } | undefined;
    suppressNavigable?: boolean | import("ag-grid-community").SuppressNavigableCallback<any, any> | undefined;
    suppressKeyboardEvent?: ((params: import("ag-grid-community").SuppressKeyboardEventParams<any, any>) => boolean) | undefined;
    suppressPaste?: boolean | import("ag-grid-community").SuppressPasteCallback<any, any> | undefined;
    suppressFillHandle?: boolean | undefined;
    hide?: boolean | undefined;
    initialHide?: boolean | undefined;
    lockVisible?: boolean | undefined;
    lockPosition?: boolean | "left" | "right" | undefined;
    suppressMovable?: boolean | undefined;
    useValueFormatterForExport?: boolean | undefined;
    editable?: boolean | import("ag-grid-community").EditableCallback<any, any> | undefined;
    valueSetter?: string | import("ag-grid-community").ValueSetterFunc<any, any> | undefined;
    valueParser?: string | import("ag-grid-community").ValueParserFunc<any, any> | undefined;
    cellEditor?: any;
    cellEditorParams?: any;
    cellEditorSelector?: import("ag-grid-community").CellEditorSelectorFunc<any, any> | undefined;
    singleClickEdit?: boolean | undefined;
    cellEditorPopup?: boolean | undefined;
    cellEditorPopupPosition?: "over" | "under" | undefined;
    useValueParserForImport?: boolean | undefined;
    onCellValueChanged?: ((event: import("ag-grid-community").NewValueParams<any, any>) => void) | undefined;
    onCellClicked?: ((event: import("ag-grid-community").CellClickedEvent<any, any>) => void) | undefined;
    onCellDoubleClicked?: ((event: import("ag-grid-community").CellDoubleClickedEvent<any, any>) => void) | undefined;
    onCellContextMenu?: ((event: import("ag-grid-community").CellContextMenuEvent<any, any>) => void) | undefined;
    getQuickFilterText?: ((params: import("ag-grid-community").GetQuickFilterTextParams<any, any>) => string) | undefined;
    filterValueGetter?: string | import("ag-grid-community").ValueGetterFunc<any, any> | undefined;
    floatingFilter?: boolean | undefined;
    suppressFloatingFilterButton?: boolean | undefined;
    wrapHeaderText?: boolean | undefined;
    autoHeaderHeight?: boolean | undefined;
    headerComponent?: any;
    headerComponentParams?: any;
    menuTabs?: import("ag-grid-community").ColumnMenuTab[] | undefined;
    columnChooserParams?: import("ag-grid-community").ColumnChooserParams | undefined;
    columnsMenuParams?: import("ag-grid-community").ColumnsMenuParams | undefined;
    suppressMenu?: boolean | undefined;
    suppressHeaderMenuButton?: boolean | undefined;
    suppressHeaderFilterButton?: boolean | undefined;
    suppressHeaderContextMenu?: boolean | undefined;
    mainMenuItems?: (string | import("ag-grid-community").MenuItemDef<any, any>)[] | import("ag-grid-community").GetMainMenuItems<any, any> | undefined;
    contextMenuItems?: (string | import("ag-grid-community").MenuItemDef<any, any>)[] | import("ag-grid-community").GetContextMenuItems<any, any> | undefined;
    headerCheckboxSelection?: boolean | import("ag-grid-community").HeaderCheckboxSelectionCallback<any, any> | undefined;
    headerCheckboxSelectionFilteredOnly?: boolean | undefined;
    headerCheckboxSelectionCurrentPageOnly?: boolean | undefined;
    chartDataType?: "time" | "category" | "series" | "excluded" | undefined;
    pinned?: boolean | "left" | "right" | null | undefined;
    initialPinned?: boolean | "left" | "right" | undefined;
    lockPinned?: boolean | undefined;
    pivot?: boolean | undefined;
    initialPivot?: boolean | undefined;
    pivotIndex?: number | null | undefined;
    initialPivotIndex?: number | undefined;
    pivotComparator?: ((valueA: string, valueB: string) => number) | undefined;
    enablePivot?: boolean | undefined;
    cellStyle?: import("ag-grid-community").CellStyle | import("ag-grid-community").CellStyleFunc<any, any> | undefined;
    cellClass?: string | string[] | import("ag-grid-community").CellClassFunc<any, any> | undefined;
    cellClassRules?: import("ag-grid-community").CellClassRules<any, any> | undefined;
    cellRenderer?: any;
    cellRendererParams?: any;
    cellRendererSelector?: import("ag-grid-community").CellRendererSelectorFunc<any, any> | undefined;
    autoHeight?: boolean | undefined;
    wrapText?: boolean | undefined;
    enableCellChangeFlash?: boolean | undefined;
    suppressCellFlash?: boolean | undefined;
    rowDrag?: boolean | import("ag-grid-community").RowDragCallback<any, any> | undefined;
    rowDragText?: ((params: import("ag-grid-community").IRowDragItem, dragItemCount: number) => string) | undefined;
    dndSource?: boolean | import("ag-grid-community").DndSourceCallback<any, any> | undefined;
    dndSourceOnRowDrag?: ((params: import("ag-grid-community").DndSourceOnRowDragParams<any>) => void) | undefined;
    rowGroup?: boolean | undefined;
    initialRowGroup?: boolean | undefined;
    rowGroupIndex?: number | null | undefined;
    initialRowGroupIndex?: number | undefined;
    enableRowGroup?: boolean | undefined;
    enableValue?: boolean | undefined;
    aggFunc?: string | import("ag-grid-community").IAggFunc<any, any> | null | undefined;
    initialAggFunc?: string | import("ag-grid-community").IAggFunc<any, any> | undefined;
    defaultAggFunc?: string | undefined;
    allowedAggFuncs?: string[] | undefined;
    showRowGroup?: string | boolean | undefined;
    sortable?: boolean | undefined;
    sort?: import("ag-grid-community").SortDirection | undefined;
    initialSort?: import("ag-grid-community").SortDirection | undefined;
    sortIndex?: number | null | undefined;
    initialSortIndex?: number | undefined;
    sortingOrder?: import("ag-grid-community").SortDirection[] | undefined;
    comparator?: ((valueA: any, valueB: any, nodeA: import("ag-grid-community").IRowNode<any>, nodeB: import("ag-grid-community").IRowNode<any>, isDescending: boolean) => number) | undefined;
    unSortIcon?: boolean | undefined;
    colSpan?: ((params: import("ag-grid-community").ColSpanParams<any, any>) => number) | undefined;
    rowSpan?: ((params: import("ag-grid-community").RowSpanParams<any, any>) => number) | undefined;
    width?: number | undefined;
    initialWidth?: number | undefined;
    minWidth?: number | undefined;
    maxWidth?: number | undefined;
    flex?: number | undefined;
    initialFlex?: number | undefined;
    resizable?: boolean | undefined;
    suppressSizeToFit?: boolean | undefined;
    suppressAutoSize?: boolean | undefined;
    pivotValueColumn?: import("ag-grid-community").Column<any> | null | undefined;
    pivotTotalColumnIds?: string[] | undefined;
    suppressSpanHeaderHeight?: boolean | undefined;
    headerName?: string | undefined;
    headerValueGetter?: string | import("ag-grid-community").HeaderValueGetterFunc<any, any> | undefined;
    headerTooltip?: string | undefined;
    headerClass?: import("ag-grid-community").HeaderClass<any, any> | undefined;
    suppressHeaderKeyboardEvent?: ((params: import("ag-grid-community").SuppressHeaderKeyboardEventParams<any, any>) => boolean) | undefined;
    columnGroupShow?: import("ag-grid-community").ColumnGroupShowType | undefined;
    toolPanelClass?: import("ag-grid-community").ToolPanelClass<any, any> | undefined;
    suppressColumnsToolPanel?: boolean | undefined;
    suppressFiltersToolPanel?: boolean | undefined;
    tooltipComponent?: any;
    tooltipComponentParams?: any;
    pivotKeys?: string[] | undefined;
    cellAriaRole?: string | undefined;
    filter?: any;
    filterParams?: any;
    floatingFilterComponent?: any;
    floatingFilterComponentParams?: any;
}[];
