"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.replaceAtMatch = exports.updateAtMatch = exports.objWithoutNull = exports.replaceAtKey = exports.replaceAtIdx = exports.replaceInArr = exports.sym = exports.requestDf = void 0;
const lodash_1 = __importDefault(require("lodash"));
const requestDf = (url, setCallBack) => {
    const retPromise = fetch(url).then((response) => __awaiter(void 0, void 0, void 0, function* () {
        const tableDf = yield response.json();
        setCallBack(tableDf);
    }));
    return retPromise;
};
exports.requestDf = requestDf;
const sym = (symbolName) => {
    return { symbol: symbolName };
};
exports.sym = sym;
function replaceInArr(arr, old, subst) {
    return arr.map((item) => (item === old ? subst : item));
}
exports.replaceInArr = replaceInArr;
function replaceAtIdx(arr, idx, subst) {
    return arr.map((item, innerIdx) => innerIdx === idx ? subst : item);
}
exports.replaceAtIdx = replaceAtIdx;
function replaceAtKey(obj, key, subst) {
    const objCopy = lodash_1.default.clone(obj);
    objCopy[key] = subst;
    return objCopy;
}
exports.replaceAtKey = replaceAtKey;
const objWithoutNull = (obj, extraStrips = []) => lodash_1.default.pickBy(obj, (x) => ![null, undefined, ...extraStrips].includes(x));
exports.objWithoutNull = objWithoutNull;
const updateAtMatch = (cols, key, subst, negative) => {
    const retColumns = cols.map((x) => {
        if (x.field === key) {
            return Object.assign(Object.assign({}, x), subst);
        }
        else {
            return Object.assign(Object.assign({}, x), negative);
        }
    });
    return retColumns;
};
exports.updateAtMatch = updateAtMatch;
const replaceAtMatch = (cols, key, subst) => {
    const retColumns = cols.map((x) => {
        if (x.field === key) {
            return Object.assign(Object.assign({}, x), subst);
        }
        else {
            return Object.assign({}, x);
        }
    });
    return retColumns;
};
exports.replaceAtMatch = replaceAtMatch;
//# sourceMappingURL=utils.js.map