"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DFViewerView = exports.DFViewerModel = exports.DCEFWidgetView = exports.DCEFWidgetModel = void 0;
const base_1 = require("@jupyter-widgets/base");
const DCFCell_1 = require("./components/DCFCell");
const react_1 = __importStar(require("react"));
const ReactDOMClient = __importStar(require("react-dom/client"));
const version_1 = require("./version");
// Import the CSS
require("ag-grid-community/styles/ag-grid.css");
require("ag-grid-community/styles/ag-theme-alpine.css");
require("./style/dcf-npm.css");
const DFViewer_1 = require("./components/DFViewerParts/DFViewer");
class DCEFWidgetModel extends base_1.DOMWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: DCEFWidgetModel.model_name, _model_module: DCEFWidgetModel.model_module, _model_module_version: DCEFWidgetModel.model_module_version, _view_name: DCEFWidgetModel.view_name, _view_module: DCEFWidgetModel.view_module, _view_module_version: DCEFWidgetModel.view_module_version });
    }
}
exports.DCEFWidgetModel = DCEFWidgetModel;
DCEFWidgetModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
DCEFWidgetModel.model_name = 'DCEFWidgetModel';
DCEFWidgetModel.model_module = version_1.MODULE_NAME;
DCEFWidgetModel.model_module_version = version_1.MODULE_VERSION;
DCEFWidgetModel.view_name = 'ExampleView'; // Set to null if no view
DCEFWidgetModel.view_module = version_1.MODULE_NAME; // Set to null if no view
DCEFWidgetModel.view_module_version = version_1.MODULE_VERSION;
class DCEFWidgetView extends base_1.DOMWidgetView {
    render() {
        this.el.classList.add('custom-widget');
        const Component = () => {
            const [_, setCounter] = (0, react_1.useState)(0);
            const forceRerender = () => {
                setCounter((x) => x + 1);
            };
            (0, react_1.useEffect)(() => {
                this.listenTo(this.model, 'change', forceRerender);
            }, []);
            const props = {};
            for (const key of Object.keys(this.model.attributes)) {
                props[key] = this.model.get(key);
                props['on_' + key] = (value) => {
                    this.model.set(key, value);
                    this.touch();
                };
            }
            return react_1.default.createElement(DCFCell_1.WidgetDCFCell, props);
        };
        const root = ReactDOMClient.createRoot(this.el);
        const componentEl = react_1.default.createElement(Component, {});
        root.render(componentEl);
    }
}
exports.DCEFWidgetView = DCEFWidgetView;
class DFViewerModel extends base_1.DOMWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: DFViewerModel.model_name, _model_module: DFViewerModel.model_module, _model_module_version: DFViewerModel.model_module_version, _view_name: DFViewerModel.view_name, _view_module: DFViewerModel.view_module, _view_module_version: DFViewerModel.view_module_version });
    }
}
exports.DFViewerModel = DFViewerModel;
DFViewerModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
DFViewerModel.model_name = 'DFViewerModel';
DFViewerModel.model_module = version_1.MODULE_NAME;
DFViewerModel.model_module_version = version_1.MODULE_VERSION;
DFViewerModel.view_name = 'DFViewerView'; // Set to null if no view
DFViewerModel.view_module = version_1.MODULE_NAME; // Set to null if no view
DFViewerModel.view_module_version = version_1.MODULE_VERSION;
class DFViewerView extends base_1.DOMWidgetView {
    render() {
        this.el.classList.add('dfviewer-widget');
        const Component = () => {
            const [_, setCounter] = (0, react_1.useState)(0);
            const forceRerender = () => {
                setCounter((x) => x + 1);
            };
            (0, react_1.useEffect)(() => {
                this.listenTo(this.model, 'change', forceRerender);
            }, []);
            const props = {};
            for (const key of Object.keys(this.model.attributes)) {
                props[key] = this.model.get(key);
                props['on_' + key] = (value) => {
                    this.model.set(key, value);
                    this.touch();
                };
            }
            return react_1.default.createElement(DFViewer_1.DFViewer, props);
            //return React.createElement(WidgetDCFCell, props);
        };
        const root = ReactDOMClient.createRoot(this.el);
        const componentEl = react_1.default.createElement(Component, {});
        root.render(componentEl);
    }
}
exports.DFViewerView = DFViewerView;
//# sourceMappingURL=dcefwidget.js.map