"use strict";
// Copyright (c) Bloomberg
// Distributed under the terms of the Modified BSD License.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("@jupyter-widgets/base");
const apputils_1 = require("@jupyterlab/apputils");
const version_1 = require("./version");
const dcefwidget = __importStar(require("./dcefwidget"));
const EXTENSION_ID = 'buckaroo:plugin';
/**
 * The datagrid plugin.
 */
const datagridPlugin = {
    id: EXTENSION_ID,
    requires: [base_1.IJupyterWidgetRegistry],
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    optional: [apputils_1.IThemeManager],
    activate: activateWidgetExtension,
    autoStart: true,
};
exports.default = datagridPlugin;
/**
 * Activate the widget extension.
 */
function activateWidgetExtension(app, registry, themeManager) {
    console.log('buckaroo_widget plugin.ts after change EXTENSION_ID');
    // Exporting a patched DataGridView widget which handles dynamic theme changes
    registry.registerWidget({
        name: version_1.MODULE_NAME,
        version: version_1.MODULE_VERSION,
        exports: Object.assign({}, dcefwidget),
    });
}
//# sourceMappingURL=plugin.js.map